/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012, 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.editor.sections.Resource"); //$NON-NLS-1$

dojo.require("jazz.core.loader"); //$NON-NLS-1$
dojo.require("dijit._Templated");//$NON-NLS-1$
dojo.require("dijit.form.TextBox"); //$NON-NLS-1$
dojo.require("dijit.form.Select"); //$NON-NLS-1$
dojo.require("jazz.ui.ListBox"); //$NON-NLS-1$

dojo.require("dojo.data.ItemFileReadStore");//$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.editor.EditorUtils"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.Select"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeUtils"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.editor.sections._SectionMixin"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.editor.sections.ActionEditTable"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.editor.sections.ComponentParamsEditTable"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.editor.SectionDialog"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.base.internal.canvas.DiagramEditor"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ConfigFormEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){
	
var messages = {};

var DEFAULT_COMPONENT_TYPE = "baseResourceNode"; //$NON-NLS-1$ 

var TARGET_CONDITION_OPERATORS = {AND_OR: "AND_OR", OR_AND: "OR_AND"}; //$NON-NLS-1$ //$NON-NLS-2$

var load_async = jazz.core.loader.load_async;
var util = com.ibm.relm.explorer.web.ui.internal.util;
var nodeUtils = com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeUtils;
var editorUtils = com.ibm.relm.explorer.web.ui.internal.editor.EditorUtils;
var SectionDialog = com.ibm.relm.explorer.web.ui.internal.editor.SectionDialog;

// must be sync with AbstractLayout
var CLASS_ADD_COMMAND = "add-command"; //$NON-NLS-1$
var CLASS_EDIT_COMMAND = "edit-command"; //$NON-NLS-1$
var CLASS_DELETE_COMMAND = "delete-command"; //$NON-NLS-1$
var CLASS_DUPLICATE_COMMAND = "duplicate-button"; //$NON-NLS-1$

dojo.declare("com.ibm.relm.explorer.web.ui.internal.editor.sections.Resource", [dijit._Widget, dijit._Templated, com.ibm.relm.explorer.web.ui.internal.editor.sections._SectionMixin], { //$NON-NLS-1$
	
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/editor/sections/templates/ConfigFormResource.html"), //$NON-NLS-1$ //$NON-NLS-2$

	editMode: null,
	
	_uiPreviewComponent: null,
	
	constructor: function(){
		this._resourceNumId = dijit.getUniqueId('resourceNumId');//$NON-NLS-1$
		this._resourceIdId = dijit.getUniqueId('resourceIdId');//$NON-NLS-1$
		this._resourceNameId = dijit.getUniqueId('resourceNameId');//$NON-NLS-1$
		this._typeDropDownId = dijit.getUniqueId('typeDropDownId');//$NON-NLS-1$
		this._hidePredefinedHoversId = dijit.getUniqueId('hidePredefinedHoversId'); //$NON-NLS-1$
		this._hidePredefinedActionsId = dijit.getUniqueId('hidePredefinedActionsId'); //$NON-NLS-1$
	},

	postMixInProperties: function(){
		messages = this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ConfigFormEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	postCreate: function() {
		var titleNode = dojo.create("span"); //$NON-NLS-1$
		titleNode.appendChild(dojo.doc.createTextNode(messages.LabelResource));
	
		this.inherited(arguments);

		this.loadComponentTypeToDropdown();

		// tool bars
		this.targetToolbar.appendChild(this._createAddButton(messages.AddTargetProperty, this._handleAddTargetProperty));
		this.statusLinkToolbar.appendChild(this._createAddButton(messages.AddStatusLinkProperty, this._handleAddStatusLinkProperty));
//		this.componentParamToolbar.appendChild(this._createAddButton(messages.AddComponentParameter, this._handleAddComponentParameter));
		this.hoverToolbar.appendChild(this._createControlSet(function(){this._handleMoveHover(-1);}, function(){this._handleMoveHover(1);}, this._createAddButton(messages.AddHoverProperty, this._handleAddHoverProperty)));
		this.actionToolbar.appendChild(this._createControlSet(function(){this._handleMoveAction(-1);}, function(){this._handleMoveAction(1);}, this._createAddButton(messages.AddAction, this._handleAddAction)));
		
		var operators = [{label: messages.configEditorResourceTargetOperatorOR, value: TARGET_CONDITION_OPERATORS.OR_AND}, {label: messages.configEditorResourceTargetOperatorAND, value: TARGET_CONDITION_OPERATORS.AND_OR}];
		var onOperatorChanged = dojo.hitch(this, this._onOperatorChanged);
		this.targetTable.setupColumns(this._createTableColumns([
			{ id: "operator", name: messages.configEditorResourceTargetOperator, editable: true, options: operators, callback: onOperatorChanged, width: "10px"}, //$NON-NLS-1$ //$NON-NLS-2$
			{ id: "value", name: messages.configEditorResourceTargetConditions}, //$NON-NLS-1$
			{ id: "actions", name: messages.configEditorAction, isAction: true} //$NON-NLS-1$
		]));

		this.statusLinkTable.setupColumns([
			{ id: "type", name: messages.configEditorResourceStatusLinkType}, //$NON-NLS-1$
			{ id: "actions", name: messages.configEditorAction,	isAction: true} //$NON-NLS-1$
		]);

		this.hoverTable.setupColumns(this._createTableColumns(
				[{
					id: "label", //$NON-NLS-1$
					name: messages.configEditorResourceHoverLabel,
					editable: true, 
					callback: this.updateHoverData,
					preventEmpty: true,
					width: "120px" //$NON-NLS-1$
				},{
					id: "layout", //$NON-NLS-1$
					name: messages.configEditorResourceHoverLayout,
					editable: true, 
					callback: this.updateHoverData,
					preventEmpty: false,
					options: [
						{label: messages.configEditorResourceHoverLayout_Horizontal, value: "horizontal"}, //$NON-NLS-1$ 
						{label: messages.configEditorResourceHoverLayout_Vertical, value: "vertical"} //$NON-NLS-1$
					],
					width: "100px"//$NON-NLS-1$
				},{
					id: "baseQueryId", //$NON-NLS-1$
					name: messages.configEditorResourceHoverQueryId,
					editable: true, 
					callback: this.updateHoverData,
					preventEmpty: false,
					options: dojo.hitch(this, function(){
						// query in hover
						var queries = this._getHoverQueryDropdownItems();
						return dojo.map(queries, function(query){
							var ret = { label: query.id, value: query.id };
							return ret;
						});
					}),
					width: "100px"//$NON-NLS-1$
				},{
					id: "name", //$NON-NLS-1$
					name: messages.configEditorResourceHoverName,
					editable: true, 
					callback: this.updateHoverData,
					preventEmpty: true,
					width: "360px"//$NON-NLS-1$
				},{
					id: "actions", //$NON-NLS-1$
					name: messages.configEditorAction,
					isAction: true
				}
		]));
		
		this.componentParamTable.setConfigEditor(this.getConfigEditor());
		this.componentParamTable.defaultComponentType = DEFAULT_COMPONENT_TYPE;
		var selectedNode = this.getSelectedNode();
		if(selectedNode && dojo.isFunction(selectedNode.getParent)){
			var container = selectedNode.getParent();
			if(container){
				this._nodeQueryId = this.componentParamTable.targetqueryId = container.baseQueryId || container.elementId;
			}
		}

		this.actionTable.setConfigEditor(this.getConfigEditor());
		this.actionTable.setNodeQueryId(this._nodeQueryId);

		this.setResourceInfo(this.getConfig().resourceInfo);
		var firstResource = this.getConfig().resourceInfo[0];
		if(firstResource) {
			this.resourceList.setSelection([{id: firstResource.id}], true);
			this.lastSelectedId = firstResource.id;
			this.setResourceDataToPage(0);
		}
	
		this.connect(this.resourceList,"onChange", function(value) { //$NON-NLS-1$
			var selectionIndices = value.widget.getSelectionIndices();
			if(selectionIndices.length > 0){
				this.setResourceDataToPage(selectionIndices[0]);
			}
		});

		this.connect(this.resourceList,"onClick", function() { //$NON-NLS-1$
			// Reselect last selected entry if no entry is selected because jazz.ui.ListBox doesn't provide prevent removing all selection.
			var selection = this.resourceList.getSelection();
			if(!selection || selection.length <= 0){
				this.resourceList.setSelection([{id: this.lastSelectedId}], true);
			}else{
				this.lastSelectedId = selection[0].id;
			}

			// avoid to change selected Node if specified node id is duplicated or empty.
			if(!this._checkNodeId()) {
				dojo.stopEvent();
			}
		});

		this.connect(this.componentTypeDropdown, "onChange", function() { //$NON-NLS-1$
			var resource = this.getCurrentResource();
			if(resource ) {
				if(!resource.component) resource.component = {}; 
				var newValue = this.componentTypeDropdown.get("value"); //$NON-NLS-1$
				if(newValue == messages.configEditorResourceDefaultComponent) {
					if(resource.component.type == null || resource.component.type == "") { //$NON-NLS-1$
						return;
					}
					resource.component.type = ""; //$NON-NLS-1$
					this._updateDirty();
					
				} else {
					if(resource.component.type != newValue) {
						resource.component.type = newValue;
						this._updateDirty();
					}
				}
				this.componentParamTable.setResourceInfo(resource);
			}
		});
		
		this.connect(this.idTextBox,"onChange", function(newVal) { //$NON-NLS-1$
			// reflect the name change to resource dropdown list entry
			var resource = this.getCurrentResource();

			if(resource.id != newVal) { 
				if(resource) {
					resource.id = newVal;
					this._updateDirty();
				}
			}
		});
		
		this.connect(this.nameTextBox,"onChange", function(newVal) { //$NON-NLS-1$
			// reflect the name change to resource dropdown list entry
			var resource = this.getCurrentResource();

			if(resource.name != newVal) { 
				if(resource) {
					resource.name = newVal;
					this._updateDirty();
				}
				this.setResourceInfo(this.getConfig().resourceInfo);
				this.resourceList.setSelection([{id: resource.id}], true);
				this.lastSelectedId = resource.id;
			}
		});

		this.connect(this.hidePredefinedHoversCheck, "onChange", function(newVal){ //$NON-NLS-1$
			newVal = String(newVal);

			// reflect the change to resource dropdown list entry
			var resource = this.getCurrentResource();

			if(resource){
				if(resource.hidePredefinedHovers === undefined){
					if(newVal === "true"){ //$NON-NLS-1$
						resource.hidePredefinedHovers = newVal;
						this._updateDirty();
					}
				}else{
					if(resource.hidePredefinedHovers !== newVal){
						resource.hidePredefinedHovers = newVal;
						this._updateDirty();
					}
				}
			}
		});
		this.connect(this.hidePredefinedActionsCheck, "onChange", function(newVal){ //$NON-NLS-1$
			newVal = String(newVal);

			// reflect the change to resource dropdown list entry
			var resource = this.getCurrentResource();

			if(resource){
				if(resource.hidePredefinedActions === undefined){
					if(newVal === "true"){ //$NON-NLS-1$
						resource.hidePredefinedActions = newVal;
						this._updateDirty();
					}
				}else{
					if(resource.hidePredefinedActions !== newVal){
						resource.hidePredefinedActions = newVal;
						this._updateDirty();
					}
				}
			}
		});

		this.connect(this.componentParamTable, "setResourceInfo", function(){//$NON-NLS-1$
			this._updatePreview();
		});
		this.connect(this.componentParameterRow, "onShow", function(){ //$NON-NLS-1$
			this._updatePreview();
		});

		this.subscribe("/queryListChanged", "setupHoverData"); //$NON-NLS-1$//$NON-NLS-2$
	}, // postCreate

	_updatePreview: function(){
		if(this._uiPreviewComponent){
			this._uiPreviewComponent.destroy();
			this._uiPreviewComponent = null;
		}
		var uiPreview = this.uiPreview;
		var resource = this.getCurrentResource();
		if(!resource) return;
		var params = {};
		var componentInfo = resource.component || {};
		uiPreview._componentInfo = this.getDiagramEditor()._componentInfo;
		// find target componentInfo
		if(componentInfo.type){
			var compInfo = editorUtils.getComponentInfoById(componentInfo.type, this.getConfig(), this.getDiagramEditor());
			uiPreview._componentInfo = {};
			uiPreview._componentInfo[componentInfo.type] = compInfo.componentInfo; 
		}
		for(var p in componentInfo.params || []){
			params[p] = componentInfo.params[p].value;
		};
		var component = this._uiPreviewComponent = uiPreview.createComponent(componentInfo.type || DEFAULT_COMPONENT_TYPE, params);
		var h = component.getHeight();
		uiPreview.domNode.style.height = h + "px"; //$NON-NLS-1$
		var w = component.getWidth();
		uiPreview.domNode.style.width = w + "px"; //$NON-NLS-1$
		uiPreview.addChild(this._uiPreviewComponent);
		uiPreview.adjustCanvasSize();
	},

	loadComponentTypeToDropdown: function() {
		editorUtils.loadComponentTypeToDropdown(this.componentTypeDropdown, this.getConfig(), this.getDiagramEditor(), 
				{value: messages.configEditorResourceDefaultComponent, label: messages.configEditorResourceDefaultComponent});
	},

	_createControlSet: function(upFunc, downFunc, addButton) {
		var controlSet = dojo.create("div", { //$NON-NLS-1$
			});
		controlSet.appendChild(this._createArrowButton(downFunc,
				messages.moveItemDown,
				dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/down.gif"))); //$NON-NLS-1$ //$NON-NLS-2$
		controlSet.appendChild(this._createArrowButton(upFunc,
				messages.moveItemUp,
				dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/up.gif"))); //$NON-NLS-1$ //$NON-NLS-2$
		controlSet.appendChild(addButton);
		return controlSet;
	},
	

	setResourceDataToPage: function(value) {
		var index = value;
		var resource = null;

		if(index >= 0) {
			// clear
			resource = this.getConfig().resourceInfo[index];
		} 
		this.setResourceInfoDetail(resource);
	},
	
	setSelected: function(params){
		if(!params.resourceInfo)
			return;
		var resInfos = this.getConfig().resourceInfo;
		for(var i=0; i<resInfos.length; i++){
			if(params.resourceInfo == resInfos[i]){
				this.resourceList.setSelection([{id: resInfos[i].id}], true);
				this.lastSelectedId = resInfos[i].id;
				this.setResourceDataToPage(i);
				break;
			}
		}
	},
	setSelectedIndex: function(index){
		if(index < 0){
			// create a new link
			this._addResource(true);
		}else{
			var resources = this.resourceList.getEntriesByIndices([index]);
			if(resources.length > 0 && resources[0] && resources[0].id){
				this.resourceList.setSelection([{id: resources[0].id}], true);
				this.lastSelectedId = resources[0].id;
				this.setResourceDataToPage(index);
			}
		}
	},

	setResourceInfo: function(resourceInfo) {
		this.resourceList.removeAllEntries();
		this.resourceList.addEntries(dojo.map(resourceInfo, function(resource){
			var resourceName = resource.name || messages.noName;
			return {id: resource.id, value: resource, label: util.escapeHtml(resourceName)};
		}));
	},
	
	setResourceInfoDetail: function(resource) {
		this.idTextBox.set('value', (resource && resource.id) || ""); //$NON-NLS-1$ //$NON-NLS-2$
		this.nameTextBox.set('value', (resource && resource.name) || ""); //$NON-NLS-1$ //$NON-NLS-2$
		this.setTargetProperty(resource);
		this.setStatusData(resource);
		this.setComponentData(resource);
		this.setHoverData(resource);
		this.actionTable.setResourceInfo(resource);
		this.hidePredefinedHoversCheck.set("value", nodeUtils.isHidePredefinedHovers(resource)); //$NON-NLS-1$
		this.hidePredefinedActionsCheck.set("value", resource.hidePredefinedActions === "true"); //$NON-NLS-1$ //$NON-NLS-2$
		
		if(this.editMode) {
			this.setEditMode(this.editMode);
		}
	},

	setTargetProperty: function(resource) {
		// 
		var propTable = this.targetTable;
		propTable.clearItems();
		
		if(!resource) return;

		var resourceInfo = this.getCurrentResource();
		var operatorType = resourceInfo.operatorType || TARGET_CONDITION_OPERATORS.OR_AND;
		var columns = dojo.clone(propTable.columns);

		var self = this;
		var targets = resource.targetProps;
		for(var i = 0; i < targets.length; i++) {
			var targetName = dojo.string.substitute(messages.targetConditionLabel, [i+1]);
			var idx = i;
			if(i === 0){
				delete propTable.columns[0].getCellContent; // column 0 must be operator column
			}
			propTable.addItem({
				name : targetName, 
				operator: i==0 ? "" : operatorType, //$NON-NLS-1$
				value: self.getPropertyString(targets[idx]),
				index: i,
				actions: [
					{
						iconClass: CLASS_EDIT_COMMAND,
						title: messages.configEditorEditConditions,
						onClick: function(e){
							self._handleEditTargetProperty(this.data.index);
						}
					},
					{
						iconClass: CLASS_DUPLICATE_COMMAND,
						title: messages.configEditorDuplicateConditions,
						onClick: function(e){
							var index = this.data.index;
							targets.splice(index, 0, targets[this.data.index]);
							self.refreshTargetProperty(true);
							self._handleEditTargetProperty(index + 1);
						}
					},
					{
						iconClass: CLASS_DELETE_COMMAND,
						title: messages.configEditorRemoveConditions,
						onClick: function(e){
							if(this.data.name){
								if(confirm(dojo.string.substitute(messages.confirmRemoveTargetProperty, [ this.data.name ]))){
									// remove parameter
									targets.splice(this.data.index, 1);
									self.refreshTargetProperty(true);
								}
							}
						}
					}
				]
			});
			if(i === 0){
				propTable.columns = columns;
			}
		}
	},
	
	getPropertyString: function(props) {
		var ret = ""; //$NON-NLS-1$
		var resourceInfo = this.getCurrentResource();
		var insideOperator = resourceInfo.operatorType === TARGET_CONDITION_OPERATORS.AND_OR ? messages.configEditorResourceTargetOperatorOR : messages.configEditorResourceTargetOperatorAND;
		for(var i = 0; i < props.length; i++) {
			if(i!=0){
				ret += insideOperator + " "; //$NON-NLS-1$
			}
			var operator = props[i].operator || "="; //$NON-NLS-1$
			ret += "( '"+ props[i].name + "' " + operator + " '" + props[i].value + "') "; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		}
		
		return ret;
	},
	
	refreshTargetProperty: function(fModified) {
		var resource = this.getCurrentResource();
		if(resource) {
			this.setTargetProperty(resource);
			if(fModified) {
				this._updateDirty();
			}
		}
		this.setEditMode(this.editMode);
	},
	
	getCurrentResource: function() {
		var selection = this.resourceList.getSelection();
		return selection && selection.length > 0 && selection[0].value;
	},

	setStatusData: function(resource) {
		var propTable = this.statusLinkTable;
		propTable.clearItems();
		
		if(!resource) return;

		var self = this;
		var linkTypes = resource.statusLinks;
		for(var i = 0; i < linkTypes.length; i++) {
			var linkType = linkTypes[i];
			propTable.addItem({type : linkType.type, 
								index: i,
								actions: [
									{
										iconClass: CLASS_EDIT_COMMAND,
										title: messages.configEditorEditLinkType,
										onClick: function(e){
											self._handleEditStatusLinkProperty(this.data.index);
										}
									},
									{
										iconClass: CLASS_DELETE_COMMAND,
										title: messages.configEditorRemoveLinkType,
										onClick: function(e){
											if(this.data.type){
												if(confirm(dojo.string.substitute(messages.confirmRemoveLinkType, [ this.data.type ]))){
													// remove link type
													linkTypes.splice(this.data.index, 1);
													self.refreshStatusLinkProperty(true);
												}
											}
										}
									}]
			});
		}
	},
	
	refreshStatusLinkProperty: function(fModified) {
		var resource = this.getCurrentResource();
		if(resource) {
			this.setStatusData(resource);
			if(fModified) {
				this._updateDirty();
			}
		}
		this.setEditMode(this.editMode);
	},
	
	setComponentData: function(resource) {
		if(!resource || !resource.component || resource.component.type == null || resource.component.type == "") { //$NON-NLS-1$
			this.componentTypeDropdown.set("value", messages.configEditorResourceDefaultComponent); //$NON-NLS-1$
		} else {
			this.componentTypeDropdown.set("value", resource.component.type); //$NON-NLS-1$
		}
		this.componentParamTable.setResourceInfo(resource);
	},
	
	setHoverData: function(resource) {
		var propTable = this.hoverTable;
		propTable.clearItems();

		if(!resource) return;

		var self = this;
		if(resource.hoverProps) {
			dojo.forEach(resource.hoverProps, function(hover) {
				var queryId = hover.baseQueryId;
				if(queryId == null || queryId == "") { //$NON-NLS-1$
					queryId = messages.configEditorResourceHoverProperty;
				}else if(queryId == "__node_property__"){ //$NON-NLS-1$
					queryId = messages.configEditorResourceHoverNode;
				}
				propTable.addItem({
					label: hover.label,
					layout: hover.layout,
					name: hover.name || "",//$NON-NLS-1$
					baseQueryId: queryId,
					actions: [{
						iconClass: CLASS_DELETE_COMMAND,
						title: messages.Remove,
						onClick: function(e){
							if(hover.label){
								if(confirm(dojo.string.substitute(messages.confirmRemoveHoverProperty, [ hover.label ]))){
									// remove parameter
									self.removeHoverProp(hover);
								}
							}
						}
					}]
				});
//			}
			});
		}
	},
	
	removeHoverProp: function(hover) {
		var resource = this.getCurrentResource();
		if(resource) {
			for(var i = 0; i < resource.hoverProps.length; i++) {
				if(resource.hoverProps[i].label == hover.label) {
					delete resource.hoverProps.splice(i,1);
					this._updateDirty();

					break;
				}
			}
			this.setHoverData(resource);
		}
		
	},
	
	updateHoverData: function(rowData, propName, newValue, dirtyKey) {
		var label = rowData.label;
		if(label) {
			var orgProp = this.getHoverDataByLabel(label);
			var oldValue = orgProp[propName];
			orgProp[propName] = newValue;
			if(propName == "baseQueryId") { //$NON-NLS-1$
				if(newValue == messages.configEditorResourceHoverProperty) {
					orgProp.baseQueryId = ""; //$NON-NLS-1$
				}else if(newValue == messages.configEditorResourceHoverNode) {
					orgProp.baseQueryId = "__node_property__"; //$NON-NLS-1$
				}
			}
			this._updateDirty();
		}
		this.setupHoverData();
	},
	
	getHoverDataByLabel: function(label) {
		var resource = this.getCurrentResource(); 
		if(resource) {
			if(resource.hoverProps && resource.hoverProps.length > 0) {
				for(var i = 0; i < resource.hoverProps.length; i++) {
					if(resource.hoverProps[i].label == label) {
						return resource.hoverProps[i];
					}
				}
			}
		}
		
	},

	
	setupHoverData: function() {
		var resource = this.getCurrentResource();
		if(resource) {
			this.setHoverData(resource);
		}
	},
	
	refreshHoverData: function() {
		this._updateDirty();
		var resource = this.getCurrentResource();
		resource.hidePredefinedHovers = String(this.hidePredefinedHoversCheck.get("value")); // Set hidePredefinedHovers explicitly //$NON-NLS-1$
		this.setupHoverData();
		this.setEditMode(this.editMode);
	},

	_handleAddTargetProperty: function() {
		this._handleEditTargetProperty(-1);
	},
	
	_handleEditTargetProperty: function(index) {
		var resource = this.getCurrentResource();
		if(resource) {
			load_async("com.ibm.relm.explorer.web.ui.internal.editor.AddTargetPropertyContent", dojo.hitch(this, function() { //$NON-NLS-1$
				var queryVariables = editorUtils.getQueryVariablesForTarget(this.getDiagramEditor());
				com.ibm.relm.explorer.web.ui.internal.editor.AddTargetPropertyContent.openDialog(resource, index, dojo.hitch(this, this.refreshTargetProperty), {nameOptions: queryVariables});
			}));
		}
	},

	_handleAddStatusLinkProperty: function() {
		this._handleEditStatusLinkProperty(-1);
	},
	
	_handleEditStatusLinkProperty: function(index) {
		var resource = this.getCurrentResource();
		if(resource) {
			load_async("com.ibm.relm.explorer.web.ui.internal.editor.AddStatusLinkContent", dojo.hitch(this, function() { //$NON-NLS-1$
				com.ibm.relm.explorer.web.ui.internal.editor.AddStatusLinkContent.openDialog(resource, index, dojo.hitch(this, this.refreshStatusLinkProperty));
			}));
		}
		
	},
	
	_handleAddComponentParameter: function() {
		this.componentParamTable.addParameter();
	},
	
	_handleAddHoverProperty: function() {
		var resource = this.getCurrentResource();
		if(resource) {
			load_async("com.ibm.relm.explorer.web.ui.internal.editor.AddHoverPropertyContent", dojo.hitch(this, function() { //$NON-NLS-1$
				var queries = this._getHoverQueryDropdownItems(true);
				var diagramEditor = this.getDiagramEditor();
				var queryVariables = editorUtils.getQueryVariablesForTarget(diagramEditor, this._nodeQueryId);
				var selectedNode = this.getSelectedNode();
				com.ibm.relm.explorer.web.ui.internal.editor.AddHoverPropertyContent.openDialog(resource, 
						{queries: queries, diagramEditor: diagramEditor, nodeProperties: queryVariables, resourceUri: selectedNode && selectedNode.uri}, 
						dojo.hitch(this, this.refreshHoverData));
			}));
		}
	},
	
	_handleMoveHover: function(dir) {
		
		var resource = this.getCurrentResource();
		if(resource) {
			var hoverProps = resource.hoverProps;
			this._handleMoveItem(dir, hoverProps, this.hoverTable, dojo.hitch(this, this.setupHoverData));
		}

	},
	
	_handleMoveAction: function(dir) {
		var resource = this.getCurrentResource();
		if(resource) {
			var actions = resource.actions;
			this._handleMoveItem(dir, actions, this.actionTable, dojo.hitch(this.actionTable, this.actionTable.refreshActionData));
		}
	},

	_handleMoveItem: function(dir, items, table, setupFunc) {
		if(items.length < 2) return;
		var index = table.getSelectedItemIndex();

		if(index >= 0) {
			var toIndex = index;
			if((dir > 0) && (index < items.length -1) ) {
				// down
				toIndex = index + 1;
			} else if((dir < 0) && (index > 0)){
				// up
				toIndex = index - 1;
			}

			if(toIndex != index) {
				this._swapNode(items, toIndex, index);
				setupFunc();
				table.selectItemByIndex(toIndex);
			}
		}
	},

	_swapNode: function (array, index1, index2){
		if( (index1 != index2) && (0 <= index1 <array.length) && (0 <= index2 <array.length)) {
			var temp = array[index1];
			array[index1] = array[index2];
			array[index2] = temp;
			return true; 
		}
		return false;
	},

	_getHoverQueryDropdownItems: function (onlyQuery){
		var queries = dojo.clone(this.getConfig().queryTemplates);
		for(var i = 0; i < queries.length ; i++) {
			if(queries[i].id == "") { //$NON-NLS-1$
				queries[i].id = this.messages.DefaultQuery;
			}
		}
		if(!onlyQuery){
			queries.unshift({id: this.messages.configEditorResourceHoverNode});
			queries.unshift({id: this.messages.configEditorResourceHoverProperty});
		}
		return queries;
	},

	_handleAddAction: function() {
		this.actionTable.addAction();
	},

	handleDuplicateResource: function(e){
		dojo.stopEvent(e);
		this._duplicateResource();
	},
	_duplicateResource: function(skipConfirm) {
		if((skipConfirm !== true) && !this._checkNodeId()) return;
		
		if(skipConfirm===true || confirm(messages.confirmAddResource)) {
			var duplicatedResource = dojo.clone(this.getCurrentResource());
			duplicatedResource.name = dojo.string.substitute(messages.CopyOf, [ duplicatedResource.name ]); 
			duplicatedResource.id = this._createNewResourceId();
			this.getConfig().resourceInfo.unshift(duplicatedResource);
			
			this._updateDirty();
			var resourceInfo = this.getConfig().resourceInfo;
			this.setResourceInfo(resourceInfo);
			if(resourceInfo.length > 0){
				this.resourceList.setSelection([{id: resourceInfo[0].id}], true);
				this.lastSelectedId = resourceInfo[0].id;
				this.setResourceDataToPage(0);
			}
		}
	},

	handleAddResource: function(e){
		dojo.stopEvent(e);
		this._addResource();
	},
	_addResource: function(skipConfirm) {
		if((skipConfirm!==true) && !this._checkNodeId()) return;

		if(skipConfirm===true || confirm(messages.confirmAddResource)) {
			// add the new resource definition at the first of
			this.getConfig().resourceInfo.unshift({
				name: this._createNewResourceName(),
				id: this._createNewResourceId(),
				targetProps: [],
				hoverProps: [],
				actions: [],
				statusLinks: [],
				component : {
					type: "", //$NON-NLS-1$
					params: {}
				}
			});
			
			this._updateDirty();
			
			var resourceInfo = this.getConfig().resourceInfo;
			this.setResourceInfo(resourceInfo);
			if(resourceInfo.length > 0){
				this.resourceList.setSelection([{id: resourceInfo[0].id}], true);
				this.lastSelectedId = resourceInfo[0].id;
				this.setResourceDataToPage(0);
			}
		}
	},
	
	_createNewResourceName: function() {
		for(var i = 0; i < this.getConfig().resourceInfo.length + 1; i++) {
			var tempName = dojo.string.substitute( this.messages.DefautResourceName, [i]);
			var isUsed = dojo.some(this.getConfig().resourceInfo, function(resource){
				return resource.name == tempName;
			});
			if(!isUsed) return tempName;
		}
		
	},
	
	_createNewResourceId: function() {
		for(var i = 0; i < this.getConfig().resourceInfo.length + 1; i++) {
			var tempId = dojo.string.substitute( "node${0}", [i]); //$NON-NLS-1$
			var isUsed = dojo.some(this.getConfig().resourceInfo, function(resource){
				return resource.id == tempId;
			});
			if(!isUsed) return tempId;
		}
	},

	handleRemoveResource: function(e){
		dojo.stopEvent(e);
		this._removeResource();
	},
	_removeResource: function() {
		var selection = this.resourceList.getSelectionIndices();
		if(selection.length <= 0){
			return;
		}
		var index = selection[0];

		var config = this.getConfig();
		var label = config.resourceInfo[index].name || messages.noName;
		if(confirm(dojo.string.substitute(messages.confirmRemoveResource, [label]))) {
			config.resourceInfo.splice(index, 1);
			this._updateDirty();
			this.setResourceInfo(config.resourceInfo);
			
			if(config.resourceInfo[0]) {
				this.resourceList.setSelection([{id: config.resourceInfo[0].id}], true);
				this.lastSelectedId = config.resourceInfo[0].id;
				this.setResourceDataToPage(0);
			} else {
				// clear fields
				this.setResourceDataToPage(-1);
				this.resourceList.removeAllEntries();
			}
		}
	},

	handleResourceOrderDown: function(e){
		dojo.stopEvent(e);
		this.moveResource(1);
	},
	handleResourceOrderUp: function(e){
		dojo.stopEvent(e);
		this.moveResource(-1);
	},
	moveResource: function(n){
		if(this._checkNodeId()){
			var resourceInfos = this.getConfig().resourceInfo;
			if(resourceInfos && resourceInfos.length > 0) {
				var selections = this.resourceList.getSelectionIndices();
				if(!selections || selections.length <= 0){
					//This must not occur
					alert(messages.noResourceSelected);
				}else{
					var selectionIndex = selections[0];
					if(selectionIndex+n >= 0 && selectionIndex+n < resourceInfos.length){
						var selectedNode = resourceInfos[selectionIndex];
						var prevNode = resourceInfos[selectionIndex+n];
						resourceInfos[selectionIndex] = prevNode;
						resourceInfos[selectionIndex+n] = selectedNode;
						this.setResourceInfoAfterReorder(resourceInfos);
					}
				}
			} else {
				alert(messages.noResourceDefined);
			}
		}
	},
	
	_checkNodeId: function() {
		var id = this.idTextBox.get("value"); //$NON-NLS-1$
		if(id == "") { //$NON-NLS-1$
			// warn empty id
			alert(messages.nodeIdEmpty);
			dijit.focus(this.idTextBox.domNode);
			return false;
		} else {
			var resourceInfo = this.getConfig().resourceInfo;
			for(var i=0; i<resourceInfo.length; i++){
				var id = resourceInfo[i].id;
				var duplicatedIds = dojo.filter(resourceInfo, function(resource){
					return resource.id === id;
				});
				if(duplicatedIds.length >= 2) {
					// warn duplicated id
					alert(dojo.string.substitute(messages.nodeIdDuplicated, [id]));
					dijit.focus(this.idTextBox.domNode);
					return false;
				}
			}
		}
		
		return true;
	},
	
	setResourceInfoAfterReorder: function(resourceInfo) {
		var selectedResource = this.getCurrentResource();
		var config = this.getConfig();
		config.resourceInfo = resourceInfo;
		this.setResourceInfo(config.resourceInfo);
		this._updateDirty();

		var index = dojo.indexOf(config.resourceInfo, selectedResource);
		if(config.resourceInfo[index]) {
			this.resourceList.setSelection([{id: config.resourceInfo[index].id}], true);
			this.lastSelectedId = config.resourceInfo[index].id;
			this.setResourceDataToPage(index);
		}
	},

	setEditMode: function(editMode) {
		if(!editMode) return;

		this.editMode = editMode;
		var mode = editMode.resource;

		this.resourceSection.style.display = mode.resourceSection ? "" : "none"; //$NON-NLS-1$ //$NON-NLS-2$
		this.resourceSelectRow.style.display = mode.resourceSelectRow ? "" : "none"; //$NON-NLS-1$ //$NON-NLS-2$
		this.targetRow.style.display = mode.targetRow ? "" : "none"; //$NON-NLS-1$ //$NON-NLS-2$
		this.statusLinkRow.style.display = mode.statusLinkRow ? "" : "none"; //$NON-NLS-1$ //$NON-NLS-2$
		this.componentTypeRow.style.display = mode.componentTypeRow ? "" : "none"; //$NON-NLS-1$ //$NON-NLS-2$
		this.componentParameterRow.style.display = mode.componentParameterRow ? "" : "none"; //$NON-NLS-1$ //$NON-NLS-2$
		this.hoverRow.style.display = mode.hoverRow ? "" : "none"; //$NON-NLS-1$ //$NON-NLS-2$
		this.actionRow.style.display = mode.actionRow ? "" : "none"; //$NON-NLS-1$ //$NON-NLS-2$

		if(editMode.common.hideEmptyTable) {
			var resource = this.getCurrentResource();
			if(resource) {
				var targets = resource.targetProps;
				if (!targets || (targets.length == 0)) {
					this.targetRow.style.display = "none"; //$NON-NLS-1$
				}
				
				if(!resource.component || editorUtils.isEmptyObj(resource.component.params)) {
					this.componentParameterRow.style.display = "none"; //$NON-NLS-1$
				}

				var hoverProps = resource.hoverProps;
				if (!hoverProps || (hoverProps.length == 0)) {
					this.hoverRow.style.display = "none"; //$NON-NLS-1$
				}

				var actions = resource.actions;
				if (!actions || (actions.length == 0)) {
					this.actionRow.style.display = "none"; //$NON-NLS-1$
				}
			}
		}

		var readonly = editMode.common.disableActionButton ? true : false;
		this.componentTypeDropdown.set("readOnly", readonly); //$NON-NLS-1$

		var displayType = editMode.common.disableActionButton ? "none" : ""; //$NON-NLS-1$ //$NON-NLS-2$ 
		dojo.query("."+CLASS_ADD_COMMAND).style("display", displayType); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.query("."+CLASS_EDIT_COMMAND).style("display", displayType); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.query("."+CLASS_DELETE_COMMAND).style("display", displayType); //$NON-NLS-1$ //$NON-NLS-2$

		if(this.componentTypeRow.style.display === ""){//$NON-NLS-1$ 
			this.uiPreview.adjustCanvasSize();
		}
	},
	
	_editComponentInfo: function(e) {
		dojo.stopEvent(e);
		var config = dojo.clone(this.getConfig());
		var uiType = this.componentTypeDropdown.get("value"); //$NON-NLS-1$
		var self = this;
		SectionDialog.openComponentInfoDialog({
			getConfig: function(){ return config; },
			getDiagramEditor: function(){ return self.getDiagramEditor(); },
			getSelectedType: function(){ return uiType; },
			_updateDirty: function() {
				// do nothing during editing. edit result will be applied to original config at onOK callback
				self._updateDirty();
			}
		}, 
		null, 
		function(){
			dojo.mixin(self.getConfig().componentInfo, config.componentInfo);
			self.loadComponentTypeToDropdown();
			// select the UI type selected before opened UI type dialog
			// it is better to show a message dialog if user changed the UI type in the UI type dialog 
			self.setComponentData(self.getCurrentResource());
		}, 20, 20);
	},

	validate: function(values) {
		return this._checkNodeId();
	},

	destroy: function() {
		if(this._uiPreviewComponent){
			this._uiPreviewComponent.destroy();
			this._uiPreviewComponent = null;
		}
		if(this.uiPreview) {
			this.uiPreview.destroy();
			this.uiPreview = null;
		}
		this.inherited(arguments);
	},

	_onOperatorChanged: function(rowData, propName, newValue, dirtyKey){
		if(newValue){
			var resourceInfo = this.getCurrentResource();
			resourceInfo.operatorType = newValue;
		}
		this.refreshTargetProperty(true);
	}
});

})();

