/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012,2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.ConfigList"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.common.ListPage"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.ViewClient"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.MoveView"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.page.MetaNav"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.page.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.wizard.CreateNewDiagramWizard"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.util');//$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ConfigListMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){
	
var ROWTYPE_FOLDER = "folder"; //$NON-NLS-1$
var ServiceResponseHandler = com.ibm.relm.explorer.web.explorer.page.ServiceResponseHandler;

dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.ConfigList",  //$NON-NLS-1$
		com.ibm.relm.explorer.web.ui.internal.common.ListPage,
{
	_collapseIcon : dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/view/images/collapse.gif"), //$NON-NLS-1$ //$NON-NLS-2$
	_expandIcon : dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/view/images/expand.gif"), //$NON-NLS-1$ //$NON-NLS-2$
	_resourceIcon : dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/images/view.gif"), //$NON-NLS-1$ //$NON-NLS-2$

	_serviceURL : com.ibm.relm.explorer.web.ui.configServiceUri,
	_serviceClient : com.ibm.relm.explorer.web.ui.internal.view.ViewClient,
	_moveCopyDialog : com.ibm.relm.explorer.web.ui.internal.view.MoveView,

	actionPrefix : "#action=com.ibm.relm.explorer.web.showViewList", //$NON-NLS-1$
	selectAction: "#action=com.ibm.relm.explorer.web.showDiagram&viewUri=", //$NON-NLS-1$
	editFolderAction:"#action=com.ibm.relm.explorer.web.editViewFolder", //$NON-NLS-1$

	ROWTYPE_RESOURCE : "view", //$NON-NLS-1$
	_folderType: "view", //$NON-NLS-1$
		
	postMixInProperties: function() {
		this.inherited(arguments);
		var messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ConfigListMessages");		 //$NON-NLS-1$ //$NON-NLS-2$
		this._label_MyResources = messages.PrivateViews;
		this._label_SharedResources = messages.SharedViews;
		this._label_createResource = messages.createView;
		this._label_deleteResource = messages.deleteViewMsg;
		this._label_deleteResources = messages.deleteViewsMsg;
		this._label_moveResources = messages.moveViews;
		this._label_moveResource = messages.moveView;
		this._messages = messages;
	},

	_addToolbarButtons: function(toolbar){
		var messages = this._messages;
		toolbar.addButton(this, this._exportViews, {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","explorer/images/export_co.gif"), label: messages.exportViews, requiresSelection:true}); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	_setCSHelp: function(){
		if(this.shared == true) this.metanav.createContextSensitiveHelp("com.ibm.relm.explorer.web.page_SharedViews001"); //$NON-NLS-1$
		else this.metanav.createContextSensitiveHelp("com.ibm.relm.explorer.web.page_MyViews001"); //$NON-NLS-1$
	},

	_deleteItems: function()
	{
		var messages = this._messages;
		var items = this._getCheckedItems(true);
		if (items.length <= 0)
			return;
			
		var resourceItemIDs = [];
		var folderItemIDs = [];

		for (var i = 0; i < items.length; i++)
		{
			var item = items[i];
			if (item.rowType == this.ROWTYPE_RESOURCE)
				resourceItemIDs.push(item.id);
			else if (item.rowType == ROWTYPE_FOLDER)
				folderItemIDs.push(item.id);
		}

		var confirmMsg = ""; //$NON-NLS-1$
		if (resourceItemIDs.length > 0 && folderItemIDs.length > 0)
			confirmMsg = dojo.string.substitute(messages.confirmDelViewsAndFolders, [resourceItemIDs.length, folderItemIDs.length]);
		else if (resourceItemIDs.length > 0)
			confirmMsg = dojo.string.substitute(messages.confirmDelViews, [resourceItemIDs.length]);
		else
			confirmMsg = dojo.string.substitute(messages.confirmDelFolders, [folderItemIDs.length]);
		
		if (!confirm(confirmMsg)) {
			return;
		}
		
		if(! this._confirmToDelete(folderItemIDs, resourceItemIDs)){
			return;
		}

		this._deletedTypes = 0;
		var responseHandler;
		//Delete the queries if any
		if (resourceItemIDs.length > 0) 
		{
			this._deletedTypes++;
			var args = {
    			configURIs: resourceItemIDs
    		};
			responseHandler = new ServiceResponseHandler(this, "_resourcesDeleted", "_remoteError"); //$NON-NLS-1$ //$NON-NLS-2$
			this._serviceClient.deleteResourceDescriptors(responseHandler, args);
		}
		
		if (folderItemIDs.length > 0) 
		{
			this._deletedTypes++;
			var folderArgs = {
				folderUUIDs: folderItemIDs
			};
			//Delete the folders
			responseHandler = new ServiceResponseHandler(this, "_resourcesDeleted", "_remoteError"); //$NON-NLS-1$ //$NON-NLS-2$
			this._serviceClient.postDeleteFolderDescriptors(responseHandler, folderArgs);
		}
	},

	_newResource: function() {
		com.ibm.relm.explorer.web.ui.internal.wizard.CreateNewDiagramWizard.openWizard(this.shared);
	},

	_editResource: function(r)
	{
    	window.location.href = "#action=com.ibm.relm.explorer.web.showEditor&viewUri="+r.name.value + "&viewName="+encodeURIComponent(r.name.label); //$NON-NLS-1$ //$NON-NLS-2$
	},

	_confirmToDelete: function(folderItemIDs, resourceItemIDs){
		// check dirty view and confirm close it
		var viewUris = dojo.clone(resourceItemIDs);
		for(var i = 0; i < folderItemIDs.length; i++) {
			this._addAllChildViewsForClose(folderItemIDs[i], viewUris);
		}				
		if(!this.page.deleteViews(viewUris)) {
			return false;
		}
		return true;
	},
	
	_addAllChildViewsForClose: function(uuid, viewUris) {
		var folderChildren = this._childMap[uuid];
		if(folderChildren){
			for(var i = 0; i < folderChildren.length; i++){
				var child = this.getTr(folderChildren[i]); 
				if(child){
					if( child._rowType == "view") { //$NON-NLS-1$
						viewUris.push(child.getAttribute('data-guid')); //$NON-NLS-1$
					} else {
						this._addAllChildViewsForClose(child.getAttribute('data-guid'), viewUris); //$NON-NLS-1$
					}
				}
			}
		}
		
	},
	
	_deleteResource: function(r) {
		var messages = this._messages;
		if (!confirm(dojo.string.substitute(messages.confirmDelView, [com.ibm.relm.common.web.ui.util.unescapeHtml(r.name.label)]))) {
			return;
		}

		// check dirty view and confirm close it		
		if(!this.page.deleteView(r.name.value)) {
			return;
		}
		
		var args = {
				configURI: r.name.value
		};
		var responseHandler = new ServiceResponseHandler(
				this,
				"_resourceDeleted", //$NON-NLS-1$
		"_remoteError"); //$NON-NLS-1$
		var rowNode = this.getTr(r.name.value); 
		if(rowNode){
			this._pendingDeleteResourceNode = rowNode;
		}
		this._serviceClient.deleteResourceDescriptor(responseHandler, args);
		this._rootFolder = this._filterDeletedResource(r,this._rootFolder);
	},
	
	_exportViews: function(){
		var items = this._getCheckedItems(false);
		if (items.length <= 0)
			return;
			
		var resourceItemIDs = [];
		for (var i = 0; i < items.length; i++) {
			var item = items[i];
			if (item.rowType == this.ROWTYPE_RESOURCE)
				resourceItemIDs.push(item.id);
		}

		if (resourceItemIDs.length > 0)	{
			var downloadFile=com.ibm.relm.common.web.ui.util.downloadFile(this._serviceURL + "?method=exportViews", "configURIs", resourceItemIDs, true); //$NON-NLS-1$ //$NON-NLS-2$
		}
	},

    onResourceSelected: function(target){
		this._previousSelectedResourceUri = target._uri_;
		window.location.href = this.selectAction + target._uri_ + "&viewName="+encodeURIComponent(target._name_); //$NON-NLS-1$
	}
});
})();
