/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.edit.LifecycleElementParameterContent"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("jazz.ui.HoverPopup"); //$NON-NLS-1$
dojo.require("com.ibm.relm.common.web.ui.internal.util"); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.internal.queryparams.SystemParameterUtil'); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.Table"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.TableUtils"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.Select"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.EnumerationUtils"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "LifecycleElementParameterContentMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var util = com.ibm.relm.common.web.ui.internal.util;
var exputil = com.ibm.relm.explorer.web.ui.internal.util;
var tableUtils = com.ibm.relm.explorer.web.ui.internal.view.common.TableUtils;
var enumUtils = com.ibm.relm.explorer.web.ui.internal.view.common.EnumerationUtils;
var systemParameterUtil = com.ibm.relm.common.web.ui.internal.queryparams.SystemParameterUtil;
var HoverPopup = jazz.ui.HoverPopup;
var MODE_FIXVALUE = "fix"; //$NON-NLS-1$
var MODE_VIEW = "view"; //$NON-NLS-1$
var MODE_NOUSE = "nouse"; //$NON-NLS-1$

dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.edit.LifecycleElementParameterContent", [dijit._Widget, dijit._Templated] , { //$NON-NLS-1$
	widgetsInTemplate: true,
	templateString: "<div class='com-ibm-relm-explorer-setparametertable com-ibm-relm-le-setparametertable'><div dojoType='com.ibm.relm.explorer.web.ui.internal.view.common.Table' dojoAttachPoint='_paramTable' inlineEdit='false' style='table-layout: fixed; width:100%;'></div></div>",//$NON-NLS-1$

	postMixInProperties: function() {
		this.inherited(arguments);
		this._popups = [];
		this._messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "LifecycleElementParameterContentMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "CreateNewDiagramWizardMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this.datamessages = dojo.i18n.getLocalization('com.ibm.relm.common.web.ui.internal.queryparams.paramprompt', 'DataPromptMessages'); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	postCreate: function(){
		this.inherited(arguments);
		dojo.style(this.domNode, {"table-layout": "fixed"}); //$NON-NLS-1$ //$NON-NLS-2$
		this._initTable();

		var params = [];
		var parameters = this.element.parameters;
		for (name in parameters) {
			var param = parameters[name];
			var label = param.label;
			var name = param.name;
			var type = param.type ? param.type : "string"; //$NON-NLS-1$
			var value = param.value ? param.value : type === "boolean" ? false : ""; //$NON-NLS-1$ //$NON-NLS-2$
			if (param.parameterClass == "system") //$NON-NLS-1$
				type = param.parameterClass + ":" + type; //$NON-NLS-1$
			else if (param.parameterClass == "enum") {//$NON-NLS-1$
				type = param.parameterClass;
				enumtype = param.type;
			}
			var mode = param.mode ? param.mode : MODE_NOUSE;
			var description = param.description ? param.description : ""; //$NON-NLS-1$

			var newparam = {name: name, label: label, value: value, type: type, mode: mode, description: description};
			var alternativeType = param.alternativeType;
			if(alternativeType){
				newparam.alternativeType = alternativeType;
			}
			if (type == "enum") //$NON-NLS-1$
				newparam.enumtype = enumtype;

			// re-edit mode overrides default properties
			if (this.props) {
				if (this.props[name]) {
					var p = dojo.clone(this.props[name]);
					delete p.alternativeType; // alternativeType in AE is always prior
					p.mode = p.isuserparam ? MODE_VIEW : MODE_FIXVALUE;
					delete p.isuserparam;
					dojo.mixin(newparam, p);

					// use values specified by artifact element
					newparam.label = label;
					newparam.description = description;
					newparam.type = type;
					if (type == "enum") {//$NON-NLS-1$
						newparam.enumtype = enumtype;
					} else if (type == "string" && dojo.isObject(newparam.value) && newparam.value.substitution) { //$NON-NLS-1$
						// assume the value was enum, but now string type
						newparam.value = newparam.value.substitution;
					}
				} else {
					newparam.mode = MODE_NOUSE;
				}

				if (this._isSystemParam(newparam))
					newparam.value = systemParameterUtil.getValues(type.substr(7)).displayValue;
			}
			params.push(newparam);
		}
		this.setParameters(params);
	},

	destroy: function(){
		this.inherited(arguments);
		dojo.forEach(this._popups, function(popup){popup.destroy();});
	},
	
	setParameters: function(params){
		if (!params) {
			this._setParameters(params);
			return;
		}
		enumUtils.loadEnum(dojo.hitch(this, function(enums) {
			this.enums = enums;
			if (dojo.some(params, function(param) { return enumUtils.isEnumType(param.type, enums); })) {
				this._setParameters(params, enums);
			} else {
				// If there is no enum type in params, call immediately
				this._setParameters(params);
			}
		}));
	},

	_initTable: function() {
		var propTable = this._paramTable;
		propTable.setupColumns(this._createColumns());
	},
	
	_createColumns: function() {
		var self = this;
		var columns = tableUtils.createTableColumns([
			{
				id: "label", //$NON-NLS-1$
				name: this._messages.parameterName,
				style: "width: 35%", //$NON-NLS-1$
			},
			{
				id: "value", //$NON-NLS-1$
				name: this._messages.parameterValue,
				style: "width: 65%", //$NON-NLS-1$
				editable: true
			},
			{
				id: "mode", //$NON-NLS-1$
				name: this._messages.parameterType,
				style: "width: 110px", //$NON-NLS-1$
				className: "relm-param-valuemode", //$NON-NLS-1$
				editable: true
			}
		], this);
		
		columns[0].style = "width: 35%", //$NON-NLS-1$
		columns[1].style = "width: 60%", //$NON-NLS-1$
		columns[2].style = "width: 110px", //$NON-NLS-1$
		
		columns[2].className = "relm-param-valuemode", //$NON-NLS-1$
		
		columns[0].getCellContent = function(cellData) {
			var rowWidget = this;
			var div = dojo.create("span"); //$NON-NLS-1$
			dojo.create("label", {innerHTML : exputil.escapeHtml(cellData)}, div); //$NON-NLS-1$
			var desc = rowWidget.data.description;
			if(desc && desc.length > 0) {
				dojo.addClass(div, 'jazz-app-ua-TextHoverHelp'); //$NON-NLS-1$
				self._popups.push(new HoverPopup({
					around: div,
					html: exputil.escapeHtml(desc),
					openDelay: 300
				}));
			}
			return div;
		};
		
		return columns;
	},

	_getEditButton: function(type, value, alternativeType){
		return dojo.when(util.hasPicker(type), dojo.hitch(this, function(hasPicker){
			if(hasPicker){
				var button = dojo.create("a", { //$NON-NLS-1$
					href: "#", //$NON-NLS-1$
					title: this.messages.openSelectDialog,
					style: "display: none;", //$NON-NLS-1$
					className: "dijitInline actionIcon" //$NON-NLS-1$
				});
				this.connect(button, "onclick", function(ev){//$NON-NLS-1$
					var initialValue = button.targetColumn ? button.targetColumn.get("value") : value; //$NON-NLS-1$
					util.openPicker(type, initialValue, this.messages.paramSelectParameterValue, function(value){
						if(value.uri){
							value = value.uri; // artifact picker and product picker
						}
						button.targetColumn.set("value", value); //$NON-NLS-1$
						this.close();
					});
					dojo.stopEvent(ev);
				});
				dojo.create("span", { //$NON-NLS-1$
					className: "dijitInline selectButton" //$NON-NLS-1$
				}, button);

				button.editInPlace = true;
				button.style.display = ""; //$NON-NLS-1$
				return button;
			}else if(type != alternativeType && alternativeType){
				return this._getEditButton(alternativeType, value);
			}
		}));
	},
	
	_getOptions: function(param, enums) {
		var type = param.type;
		var options = null;
		if (enums && enumUtils.isEnumType(type, enums)) {
			var category = enumUtils.getEnumCategory(param.enumtype || type, enums);
			options = enumUtils.getEnumValueOptions(enums, category, this.datamessages.selectValue);
		} else {
			options = null;
		}

		var modeOptions = [
			{label: this._messages.paramOptional, value: MODE_VIEW, selected: param.mode == MODE_VIEW},
			{label: this._messages.paramFixed, value: MODE_FIXVALUE, selected: param.mode == MODE_FIXVALUE},
			{label: this._messages.paramNoUse, value: MODE_NOUSE, selected: param.mode == MODE_NOUSE}];
		
		return {value: options, mode: modeOptions};
	},
	
	_setParameters: function(params, enums){
		this.parameters = params;
		this._paramTable.clearItems();
		
		if (!params) return;
		
		var propTable = this._paramTable;
		var self = this;
		dojo.forEach(this.parameters, function(param) {
			var type = param.type;
			var value = param.value;
			
			var readonlyKeys = null;
			if (self._isSystemParam(param)) {
				readonlyKeys = ["value"]; //$NON-NLS-1$
			} else if (enumUtils.isEnumType(param.type, enums)) {
				value = enumUtils.getEnumValue(param.value);
			}

			propTable.addItem({name: param.name,
								label: param.label,
								value: value,
								mode: param.mode,
								description: param.description,
								readonlyKeys: readonlyKeys,
								param: param,
								editButton: self._getEditButton(type, value, param.alternativeType),
								datatypes: {value: type},
								buttonTarget: "value"//$NON-NLS-1$
								}, self._getOptions(param, enums),
								function(data, id, newValue, rowWidget) {
									// push newValue back to data
									data.param[id] = newValue;
									
									var newMode = null;
									if (id == "value") { //$NON-NLS-1$
										var valueChanged = !dojo.isString(newValue) || newValue.length > 0;
										var valueEmpty = dojo.isString(newValue) && newValue.length == 0;
										if (valueChanged && data.param.mode == MODE_NOUSE) {
											newMode = MODE_FIXVALUE; // Set Fixed Value when value is specified
										} else if (valueEmpty) {
											newMode = MODE_NOUSE; // Set Not Used when value gets empty
										}
									}
									
									if (newMode) {
										data.param.mode = newMode;
										dojo.forEach(dijit.findWidgets(rowWidget.getCellByColumnId("mode")), function(widget) { //$NON-NLS-1$
											if (widget instanceof dijit.InlineEditBox) {
												widget.set("value", newMode); //$NON-NLS-1$
												var options = widget.editorParams.optionsArray;
												dojo.forEach(options, function(opt) {
													opt.selected = opt.value == newMode;
												});
											} else if (widget.editWidget instanceof com.ibm.relm.explorer.web.ui.internal.view.common.Select) {
												var options = widget.editWidget.optionsArray;
												widget.editWidget.setOptions(dojo.map(options, function(opt) {
													opt.selected = opt.value == newMode;
													return opt;
												}));
											} else if (widget instanceof com.ibm.relm.explorer.web.ui.internal.view.common.Select) {
												var options = widget.optionsArray;
												widget.setOptions(dojo.map(options, function(opt) {
													opt.selected = opt.value == newMode;
													return opt;
												}));
											}
										});
									}
								}, self);
		});
		if(dojo.isFunction(this.updatePosition)){
			this.updatePosition();
		}
	},

	_updateParamData: function(name, id, value) {
		if(this.parameters) {
			dojo.forEach(this.parameters, function(param){
				if(param.name == name)
					param[id] = value;
			});
		}
	},
	
	_isSystemParam: function(param) {
		return param.type ? param.type.substr(0, 7) == "system:" : false; //$NON-NLS-1$
	}
});

com.ibm.relm.explorer.web.ui.internal.view.edit.LifecycleElementParameterContent.openDialog = function(element, props, okCallback, left, top){

	var table = new com.ibm.relm.explorer.web.ui.internal.view.edit.LifecycleElementParameterContent({element: element, props: props});

	// show dialog
	var dialog = new com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog({
		primaryTitle: dojo.string.substitute(table._messages.paramDialogTitle, [element.title]),
		headerContent: {
			mainMessage: table._messages.paramDialogHeader,
			contentHelpId: "com.ibm.relm.explorer.web.page_SetParameters001", //$NON-NLS-1$
			mainHtmlMessage: dojo.string.substitute(table._messages.paramDialogText, [exputil.escapeHtml(element.title)])
		},
		dialogContent: table,
		width: "570px", //$NON-NLS-1$
		isClosable: true,
		validate: function(values, callback) {
			// all parameter is set correctly
			callback();
		},
		onOK: dojo.hitch(this, function(){
			var params = {};
			dojo.forEach(table.parameters, function(param) {
				if (!param || !param.mode || param.mode == MODE_NOUSE) return;
					var newParam = {label: param.label, type: param.type, value: param.value,
							isuserparam: param.mode == MODE_VIEW, mandatory: param.mode == MODE_VIEW,
							description: param.description};
					var alternativeType = param.alternativeType;
					if(alternativeType){
						newParam.alternativeType = alternativeType;
					}
					var isSystem = table._isSystemParam(param);
					if (isSystem) newParam.value = ""; //$NON-NLS-1$
					var isEnum = enumUtils.isEnumType(param.type, table.enums);
					if (isEnum) {
						var enumtype = param.enumtype || param.type;
						var enumValue = dojo.isObject(param.value) ? param.value : enumUtils.getEnumRawValue(enumtype, table.enums, param.value);
						newParam.type = "enum"; //$NON-NLS-1$
						newParam.enumtype = enumtype;
						enumUtils.updateParamByValue(newParam, enumValue);
					}
					params[param.name] = newParam;
			});
			okCallback(params);
			table.setParameters(null); // clear
		})
	});
	table.updatePosition = dojo.hitch(dialog, dialog.updatePosition);
	
	if (left) dialog.domNode.style.left = left + "px"; //$NON-NLS-1$
	if (top) dialog.domNode.style.top = top + "px"; //$NON-NLS-1$
};

})();