/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014, 2016. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.le.ui.internal.list.FolderRow"); //$NON-NLS-1$

dojo.require("com.ibm.relm.le.ui.internal.util"); //$NON-NLS-1$
dojo.require('dojo.i18n'); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.le.ui.internal.list", "FolderRowMessages"); //$NON-NLS-1$ //$NON-NLS-2$


dojo.require("com.ibm.relm.le.ui.internal.list.ListRow"); //$NON-NLS-1$

(function() {

	var ns = com.ibm.relm.le.ui.namespace;
	var FOLDER_ICON = dojo.moduleUrl("com.ibm.relm.le", "ui/images/folder.gif"); //$NON-NLS-1$ //$NON-NLS-2$
	var COLLAPSE_ICON = dojo.moduleUrl("com.ibm.relm.le", "ui/images/collapse.gif"); //$NON-NLS-1$ //$NON-NLS-2$
	var EXPAND_ICON = dojo.moduleUrl("com.ibm.relm.le", "ui/images/expand.gif"); //$NON-NLS-1$ //$NON-NLS-2$

	dojo.declare(
		"com.ibm.relm.le.ui.internal.list.FolderRow", //$NON-NLS-1$
		[com.ibm.relm.le.ui.internal.list.ListRow],
		{
			messages: dojo.i18n.getLocalization("com.ibm.relm.le.ui.internal.list", "FolderRowMessages"), //$NON-NLS-1$ //$NON-NLS-2$

			postMixInProperties: function() {
				this.inherited(arguments);
				
				this.rowType = ns.ae.Folder;
				this.folderID = this.item.id;
				this.iconSrc = FOLDER_ICON;
			},

			postCreate: function() {
				this.inherited(arguments);
				this.nameContent.innerHTML = com.ibm.relm.le.ui.internal.util.escapeHtml(this.label);
				this._updateIcon();
			},
			
			/*
			 * Internal
			 */
			_updateIcon: function(){
				this.expandoIcon.style.display = "";//$NON-NLS-1$
				this.expandoIcon.src = this._expanded ? COLLAPSE_ICON : EXPAND_ICON ;				
			}
		});
	})();